Base Module VST 3.6.11 SDK for developing VST Plug-in

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Public Member Functions | Public Attributes | Static Public Attributes | List of all members
UpdateHandler Class Reference

UpdateHandler implements IUpdateManager and IUpdateHandler to handle dependencies between objects to store and forward messages to dependent objects. More...

`#include <updatehandler.h>`

Inheritance diagram for UpdateHandler:

## Public Member Functions
| UpdateHandler ()
| ~UpdateHandler ()
virtual tresult | addDependent (FUnknown *object, IDependent *dependent) SMTG_OVERRIDE
| register More...
virtual tresult | removeDependent (FUnknown *object, IDependent *dependent) SMTG_OVERRIDE
| unregister More...
virtual tresult | triggerUpdates (FUnknown *object, int32 message) SMTG_OVERRIDE
| send More...
virtual tresult | deferUpdates (FUnknown *object, int32 message) SMTG_OVERRIDE
| send More...
virtual tresult | cancelUpdates (FUnknown *object) SMTG_OVERRIDE
| cancel pending messages send by More...
virtual tresult | triggerDeferedUpdates (FUnknown *object=0) SMTG_OVERRIDE
| send pending messages send by More...
size_t | countDependencies (FUnknown *object=nullptr)
| OBJ_METHODS (UpdateHandler, FObject) FUNKNOWN_METHODS2(IUpdateHandler
Public Member Functions inherited from FObject
| FObject ()
| default constructor... More...
| FObject (const FObject &)
| overloaded constructor... More...
virtual | ~FObject ()
| destructor... More...
FObject & | operator= (const FObject &)
| overloads operator "=" as the reference assignment More...
virtual FClassID | isA () const
| a local alternative to getFClassID () More...
virtual bool | isA (FClassID s) const
| evaluates if the passed ID is of the FObject type More...
virtual bool | isTypeOf (FClassID s, bool=true) const
| evaluates if the passed ID is of the FObject type More...
int32 | getRefCount ()
| returns the current interface reference count More...
FUnknown * | unknownCast ()
| get FUnknown interface from object More...
virtual tresult | queryInterface (const TUID _iid, void **obj) SMTG_OVERRIDE
| please refer to FUnknown::queryInterface () More...
virtual uint32 | addRef () SMTG_OVERRIDE
| please refer to FUnknown::addref () More...
virtual uint32 | release () SMTG_OVERRIDE
| please refer to FUnknown::release () More...
virtual void | update (FUnknown *, int32) SMTG_OVERRIDE
| empty virtual method that should be overridden by derived classes for data updates upon changes More...
virtual void | addDependent (IDependent *dep)
| adds dependency to the object More...
virtual void | removeDependent (IDependent *dep)
| removes dependency from the object More...
virtual void | changed (int32 msg=kChanged)
| Inform all dependents, that the object has changed. More...
virtual void | deferUpdate (int32 msg=kChanged)
| Similar to triggerUpdates, except only delivered in idle (usefull in collecting updates). More...
virtual void | updateDone (int32)
| empty virtual method that should be overridden by derived classes More...
virtual bool | isEqualInstance (FUnknown *d)

## Public Attributes
| IUpdateManager
FObject SINGLETON(UpdateHandler) private Steinberg::Base::Thread::FLock | lock
Update::Table * | table = nullptr

## Static Public Attributes
static bool | lockUpdates
Static Public Attributes inherited from FObject
static const FUID | iid
| Special UID that is used to cast an FUnknown pointer to a FObject. More...
Static Public Attributes inherited from IUpdateManager
static const FUID | iid

## Additional Inherited Members
Static Public Member Functions inherited from FObject
static FClassID | getFClassID ()
| return Class ID as an ASCII string (statically) More...
static void | setUpdateHandler (IUpdateHandler *handler)
| set method for the local attribute More...
static IUpdateHandler * | getUpdateHandler ()
| get method for the local attribute More...
static bool | classIDsEqual (FClassID ci1, FClassID ci2)
| compares (evaluates) 2 class IDs More...
static FObject * | unknownToObject (FUnknown *unknown)
| pointer conversion from FUnknown to FObject More...
Protected Attributes inherited from FObject
int32 | refCount
| COM-model local reference count. More...
Static Protected Attributes inherited from FObject
static IUpdateHandler * | gUpdateHandler = 0

## Detailed Description

UpdateHandler implements IUpdateManager and IUpdateHandler to handle dependencies between objects to store and forward messages to dependent objects.

This implementation is thread save, so objects can send message, add or remove dependents from different threads. Do do so it uses mutex, so be aware of locking.

## Constructor & Destructor Documentation

UpdateHandler | ( |  | ) |

~UpdateHandler | ( |  | ) |

## Member Function Documentation

tresult addDependent | ( | FUnknown * | object,
|  | IDependent * | dependent
| ) |  |
| virtual

register

Parameters

  dependent | to get messages from
  object |

tresult removeDependent | ( | FUnknown * | object,
|  | IDependent * | dependent
| ) |  |
| virtual

unregister

Parameters

  dependent | to get no messages from
  object |

tresult triggerUpdates | ( | FUnknown * | object,
|  | int32 | message
| ) |  |
| virtual

send

Parameters

  message | to all dependents of
  object | immediately

tresult deferUpdates | ( | FUnknown * | object,
|  | int32 | message
| ) |  |
| virtual

send

Parameters

  message | to all dependents of
  object | when idle

tresult cancelUpdates | ( | FUnknown * | object | ) |
| virtual

cancel pending messages send by

Parameters

  object | or by any if object is 0

Implements IUpdateManager.

tresult triggerDeferedUpdates | ( | FUnknown * | object = `0` | ) |
| virtual

send pending messages send by

Parameters

  object | or by any if object is 0

Implements IUpdateManager.

size_t countDependencies | ( | FUnknown * | object = `nullptr` | ) |

OBJ_METHODS | ( | UpdateHandler | ,
|  | FObject |
| ) |  |

## Member Data Documentation

IUpdateManager

FObject SINGLETON (UpdateHandler) private Steinberg::Base::Thread::FLock lock

Update::Table* table = nullptr

bool lockUpdates
| static

Empty

Copyright ©2018 Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.